unit Passwd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, wcrypt2;

type
  TPasswordForm = class(TForm)
    OkBitBtn: TBitBtn;
    CancelBitBtn: TBitBtn;
    Edit1: TEdit;
    Label1: TLabel;
    procedure CancelBitBtnClick(Sender: TObject);
    procedure OkBitBtnClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PasswordForm: TPasswordForm;

implementation

uses Main;

{$R *.DFM}

procedure TPasswordForm.CancelBitBtnClick(Sender: TObject);
begin
Edit1.Text := '';
Close;
end;

procedure TPasswordForm.OkBitBtnClick(Sender: TObject);
var hash: HCRYPTHASH;
begin
if not CryptCreateHash(MainForm.hProv, CALG_SHA, 0, 0, @hash) then
   begin
   MessageDlg('Error 1', mtError, [mbOK], 0);
   exit;
   end;
if not CryptHashData(hash, @Edit1.text[1], length(Edit1.text), 0) then
   begin
   MessageDlg('Error 2', mtError, [mbOK], 0);
   exit;
   end;
if not CryptDeriveKey(MainForm.hProv, CALG_RC4, hash, 0, @MainForm.key) then
   begin
   MessageDlg('Error 3', mtError, [mbOK], 0);
   exit;
   end;
if not CryptDestroyHash(hash) then
   begin
   MessageDlg('Error 4', mtError, [mbOK], 0);
   exit;
   end;
if MainForm.encrypt then MainForm.EncryptData
else MainForm.DecryptData;
Edit1.Text := '';
Close;
end;



procedure TPasswordForm.Edit1Change(Sender: TObject);
begin
if (Length(Edit1.Text)>0) then OkBitBtn.Enabled := true
else OkBitBtn.Enabled := false;
end;

end.
